/*
  This file is part of GerQUtils.

  GerQUtils is free software: you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation, either version 3 of the License, or (at your option) any later
  version.

  GerQUtils is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
  A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License along with
  GerQUtils.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef GERQ_DEFAULTASSOCIATOR_H
#define GERQ_DEFAULTASSOCIATOR_H


#include "gerqutilsbase.h"

#include "associator.h"


namespace GerQ {


  class DefaultAssociator: public Associator {

    public:

      DefaultAssociator(
        AssoAdapter *aAdapter, DataContainer *aCtrYin, DataContainer *aCtrYan,
	void (*aAssociate)(DataObject*, DataObject*),
	void (*aDissociate)(DataObject*, DataObject*),
	void (*aGetYanData)(DataObject*, AssoData&),
	void (*aGetYinData)(DataObject*, AssoData&));

    protected:

      virtual void associate(DataObject *aYin, DataObject *aYan);
      virtual void dissociate(DataObject *aYin, DataObject *aYan);

      virtual void getYinData(DataObject *aYan, AssoData &aYinData);
      virtual void getYanData(DataObject *aYin, AssoData &aYanData);

    private:

      void (*fAssociate)(DataObject*, DataObject*);
      void (*fDissociate)(DataObject*, DataObject*);

      void (*fGetYinData)(DataObject*, AssoData&);
      void (*fGetYanData)(DataObject*, AssoData&);

  }; // DefaultAssociator


} // GerQ


#endif
