/*
  This file is part of GerQUtils.

  GerQUtils is free software: you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation, either version 3 of the License, or (at your option) any later
  version.

  GerQUtils is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
  A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License along with
  GerQUtils.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef GERQ_SQLASSOADAPTER_H
#define GERQ_SQLASSOADAPTER_H


#include "assoadapter.h"
#include <QSqlTableModel>
#include <QString>


namespace GerQ {


  class SqlAssoAdapter: public AssoAdapter {

    public:

      SqlAssoAdapter(
        const QString &aTableName,
	const QString &aYinColumn,
	const QString &aYanColumn,
	QString aConnection = "");
      virtual ~SqlAssoAdapter();

      virtual void getYinIDs(DataObject *aYan, AssoIDs &aIDs);
      virtual void getYanIDs(DataObject *aYin, AssoIDs &aIDs);

      virtual void insertAssociation(DataObject *aYin, DataObject *aYan);
      virtual void deleteAssociation(DataObject *aYin, DataObject *aYan);

      QString getTableName();
      QString getYinColumn();
      QString getYanColumn();

    private:

      QString fConnection;

      QSqlTableModel *fTable;

      QString fYinColumn;
      QString fYanColumn;

      QString getFilter(const QString &aCol, const QVariant &aID);
      QString getFullFilter(QVariant aYinID, QVariant aYanID);

  }; // SqlAssoAdapter


} // GerQ


#endif
